//
// Created by KonstantinViesure on 26.05.22.
//

#ifndef COMPLIB_SERVER_GOTOCONTROLLER_HPP
#define COMPLIB_SERVER_GOTOCONTROLLER_HPP


class GoToController {
public:
  static GoToController &getInstance() {
    static GoToController instance;
    return instance;
  }

  GoToController(GoToController const &) = delete;

  void operator=(GoToController const &) = delete;

  static void drive_distance(double distance_m, double v_ms);

  static void turn_degrees(double angle_deg, double v_rad_s);

  static void go_to_point(double goal_x, double goal_y, double v_ms);

  static void diff_drive_inverse_kinematics(double v_m_s, double w_rad_s);

private:
  GoToController() = default;
};


#endif //COMPLIB_SERVER_GOTOCONTROLLER_HPP
